    function [o,p] = Greedy( o, p )     
    
        %set the pseudo random sequence, so the experiment is repeatable (and
        %all the students get the same results)
        s = RandStream('mt19937ar');
        RandStream.setDefaultStream(s);
        reset(s);
        
%--------------------------------------------------------------------------                
        %TODO. Choose a "fair" value for number of repeats of the greedy 
        % so it could be "fairly" compared with the ACO
        o.greedyReps = 1; %i.e.: 1, 10, 100, o.m + o.n, o.k, ...
%--------------------------------------------------------------------------                
    
        currPaths = zeros( o.greedyReps, o.n );
        inPaths = zeros( o.greedyReps, o.n );
        currLens = zeros( o.greedyReps, 1 );
               
        %for every greedy ant
        for ant = 1:o.greedyReps
                       
            %pick starting city at random and mark as used
            currPaths( ant, 1 ) = floor( (o.n-1+1) * rand + 1 );
            inPaths( ant, currPaths( ant, 1 ) ) = 1;
        
            %for every "next stop" in the tour
            for i = 2 : o.n
                minLen = realmax;     
                src = currPaths( ant, i - 1 );
                %check all cities that are not used and find the closest               
                for dst = 1 : o.n
                    if ( inPaths( ant, dst ) == 0 && src~=dst ) 
                        tmp = p.distMatrix( src, dst );
                        if (tmp < minLen)
                            minLen = tmp;
                            currPaths( ant, i ) = dst;
                        end
                    end
                end
                
                %update
                dst = currPaths( ant, i );                
                currLens( ant ) = currLens( ant ) + p.distMatrix( src, dst );
                inPaths( ant, dst ) = 1;                
            end
            
            %add cost for closing the cycle            
            currLens( ant, 1 ) = currLens( ant, 1 ) + p.distMatrix( currPaths( ant, o.n ), currPaths( ant, 1 ) );
                        
        end
        
        %find best greedy ant and remember it
        [bestLen, bestAnt] = min( currLens );                                    
        p.greedyBestPath(:) = currPaths( bestAnt, : );
        p.greedyBestLen = bestLen;
    end
